#include <windows.h>
#pragma hdrstop
#include <condefs.h>
#include "fstream.h"
#include "string.h"
#include "ebxle.h"
USERES("ebxle.res");
#pragma argsused
WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR, int nCmdShow)
{
   drawrgn=CreateRectRgn(10,10,510,390);
   mypal=new HPALETTE;
   size=new SIZE;
   filename=new char[500];
   randomize();
   SystemParametersInfo(SPI_GETWORKAREA,NULL,&workarea,NULL);
   maininst=hInstance;
   //Making the main menus
    menu1=CreateMenu();
    filemenu=CreateMenu();
    levelmenu=CreateMenu();
    enemymenu=CreateMenu();
    movemenu=CreateMenu();
    InsertMenu(filemenu,0xFFFFFFFF,MF_BYPOSITION|MF_STRING,MENUOPENID,"Open");
    InsertMenu(filemenu,0xFFFFFFFF,MF_BYPOSITION|MF_STRING,MENUSAVEID,"Save");
    InsertMenu(filemenu,0xFFFFFFFF,MF_BYPOSITION|MF_SEPARATOR,NULL,NULL);
    InsertMenu(filemenu,0xFFFFFFFF,MF_BYPOSITION|MF_STRING,MENUEXITID,"Exit");
    InsertMenu(levelmenu,0xFFFFFFFF,MF_BYPOSITION|MF_STRING,MENUPROPID,"Properties");
    InsertMenu(enemymenu,0xFFFFFFFF,MF_BYPOSITION|MF_STRING,MENUNEWENEMID,"New Enemy");
    InsertMenu(enemymenu,0xFFFFFFFF,MF_BYPOSITION|MF_STRING,MENUNEWIMGSET,"New Image Set");
    InsertMenu(movemenu,0xFFFFFFFF,MF_BYPOSITION|MF_STRING,MENUEDITMOVE,"Edit an enemy program");
    InsertMenu(movemenu,0xFFFFFFFF,MF_BYPOSITION|MF_STRING,MENUNEWMOVEMENT,"New program based on current enemy");
    InsertMenu(menu1,0xFFFFFFFF,MF_BYPOSITION|MF_POPUP,(UINT)filemenu,"File");
    InsertMenu(menu1,0xFFFFFFFF,MF_BYPOSITION|MF_POPUP,(UINT)levelmenu,"Level");
    InsertMenu(menu1,0xFFFFFFFF,MF_BYPOSITION|MF_POPUP,(UINT)enemymenu,"Items");
    InsertMenu(menu1,0xFFFFFFFF,MF_BYPOSITION|MF_POPUP,(UINT)movemenu,"Enemy Programs");

   //Setting up the WNDCLASS
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW);
    wc.hCursor = LoadCursor( NULL, IDC_ARROW );
    wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
    wc.hInstance = hInstance;
    wc.lpfnWndProc = (WNDPROC)WindowProc;
    wc.lpszMenuName = NULL;
    wc.lpszClassName = "EBXleveledit";

    hbc.style = CS_HREDRAW | CS_VREDRAW;
    hbc.cbClsExtra = 0;
    hbc.cbWndExtra = 0;
    hbc.hbrBackground = (HBRUSH)(COLOR_WINDOW);
    hbc.hCursor = LoadCursor( NULL, IDC_ARROW );
    hbc.hIcon = NULL;
    hbc.hInstance = hInstance;
    hbc.lpfnWndProc = (WNDPROC)hbproc;
    hbc.lpszMenuName = NULL;
    hbc.lpszClassName = "Header Props";

    cne.style = CS_HREDRAW | CS_VREDRAW;
    cne.cbClsExtra = 0;
    cne.cbWndExtra = 0;
    cne.hbrBackground = (HBRUSH)(COLOR_WINDOW);
    cne.hCursor = LoadCursor( NULL, IDC_ARROW );
    cne.hIcon = NULL;
    cne.hInstance = hInstance;
    cne.lpfnWndProc = (WNDPROC)cneproc;
    cne.lpszMenuName = NULL;
    cne.lpszClassName = "New Enemy Box";

    eep.style = CS_HREDRAW | CS_VREDRAW;
    eep.cbClsExtra = 0;
    eep.cbWndExtra = 0;
    eep.hbrBackground = (HBRUSH)(COLOR_WINDOW);
    eep.hCursor = LoadCursor( NULL, IDC_ARROW );
    eep.hIcon = NULL;
    eep.hInstance = hInstance;
    eep.lpfnWndProc = (WNDPROC)eepproc;
    eep.lpszMenuName = NULL;
    eep.lpszClassName = "EnemProg Box";

   if (RegisterClass(&hbc)==0)
      return 1;
   if (RegisterClass(&cne)==0)
      return 1;
   if (RegisterClass(&wc)==0)
      return 1;
   if (RegisterClass(&eep)==0)
      return 1;

   hWnd = CreateWindow("EBXleveledit",
               "EBX Level Editor",
               WS_OVERLAPPEDWINDOW,
               (workarea.right/2-320),(workarea.bottom/2-240),
               640, 480,
               NULL,
               menu1,
               hInstance,
               NULL );

   horzbar=CreateWindow("SCROLLBAR",
               NULL,
               WS_CHILD|SBS_HORZ,
               10, 390,
               500, GetSystemMetrics(SM_CXHTHUMB),
               hWnd,
               NULL,
               hInstance,
               NULL);

   vertbar=CreateWindow("SCROLLBAR",
               NULL,
               WS_CHILD|SBS_VERT,
               510, 10,
               GetSystemMetrics(SM_CYVTHUMB),380,
               hWnd,
               NULL,
               hInstance,
               NULL);
   seltext=CreateWindow("STATIC","Enemy - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,525,10,150,20,hWnd,NULL,maininst,NULL);
   selnum=CreateWindow("STATIC","NONE",WS_CHILD|SS_SIMPLE|WS_VISIBLE,595,10,150,20,hWnd,NULL,maininst,NULL);
   xtext=CreateWindow("STATIC","X - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,530,32,150,20,hWnd,NULL,maininst,NULL);
   ytext=CreateWindow("STATIC","Y - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,530,54,150,20,hWnd,NULL,maininst,NULL);
   xntext=CreateWindow("STATIC","X",WS_CHILD|SS_SIMPLE|WS_VISIBLE,555,32,150,20,hWnd,NULL,maininst,NULL);
   yntext=CreateWindow("STATIC","Y",WS_CHILD|SS_SIMPLE|WS_VISIBLE,555,54,150,20,hWnd,NULL,maininst,NULL);
   eptext=CreateWindow("STATIC","ImageSet - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,530,76,150,20,hWnd,NULL,maininst,NULL);
//   epntext=CreateWindow("STATIC"," ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,615,76,150,20,hWnd,NULL,maininst,NULL);
   epedit=CreateWindow("EDIT","",ES_NUMBER|WS_BORDER|WS_CHILD|WS_VISIBLE,605,76,25,20,hWnd,NULL,maininst,NULL);
   progtext=CreateWindow("STATIC","Movement - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,529,98,150,20,hWnd,NULL,maininst,NULL);
   progedit=CreateWindow("EDIT","",ES_NUMBER|WS_BORDER|WS_CHILD|WS_VISIBLE,607,98,25,20,hWnd,NULL,maininst,NULL);
   HPtext=CreateWindow("STATIC","Hit Pnts - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,530,120,150,20,hWnd,NULL,maininst,NULL);
   HPedit=CreateWindow("EDIT","",ES_NUMBER|WS_BORDER|WS_CHILD|WS_VISIBLE,600,120,25,20,hWnd,NULL,maininst,NULL);
   speedtext=CreateWindow("STATIC","Speed - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,530,142,150,20,hWnd,NULL,maininst,NULL);
   speededit2=CreateWindow("EDIT","",ES_NUMBER|WS_BORDER|WS_CHILD|WS_VISIBLE,600,142,25,20,hWnd,NULL,maininst,NULL);
   anirtext=CreateWindow("STATIC","Ani-rate - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,530,164,150,20,hWnd,NULL,maininst,NULL);
   aniredit=CreateWindow("EDIT","",ES_NUMBER|WS_BORDER|WS_CHILD|WS_VISIBLE,600,164,25,20,hWnd,NULL,maininst,NULL);
   seltext2=CreateWindow("STATIC","Imageset - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,525,220,150,20,hWnd,NULL,maininst,NULL);
   selnum2=CreateWindow("STATIC","NONE",WS_CHILD|SS_SIMPLE|WS_VISIBLE,595,220,150,20,hWnd,NULL,maininst,NULL);
   xtext2=CreateWindow("STATIC","X - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,530,242,150,20,hWnd,NULL,maininst,NULL);
   ytext2=CreateWindow("STATIC","Y - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,530,264,150,20,hWnd,NULL,maininst,NULL);
   xntext2=CreateWindow("STATIC","X",WS_CHILD|SS_SIMPLE|WS_VISIBLE,555,242,150,20,hWnd,NULL,maininst,NULL);
   yntext2=CreateWindow("STATIC","Y",WS_CHILD|SS_SIMPLE|WS_VISIBLE,555,264,150,20,hWnd,NULL,maininst,NULL);
   frametext=CreateWindow("STATIC","Frames - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,530,286,150,20,hWnd,NULL,maininst,NULL);
   framecombo=CreateWindow("COMBOBOX",NULL,WS_VSCROLL|CBS_DROPDOWNLIST|WS_BORDER|WS_CHILD|WS_VISIBLE,530,308,100,90,hWnd,NULL,maininst,NULL);

   editprogtext=CreateWindow("STATIC","Program being edited - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,50,410,150,20,hWnd,NULL,maininst,NULL);
   editprogntext=CreateWindow("STATIC","NONE",WS_CHILD|SS_SIMPLE|WS_VISIBLE,200,410,50,20,hWnd,NULL,maininst,NULL);
   numofstepstext=CreateWindow("STATIC","# of steps - ",WS_CHILD|SS_SIMPLE|WS_VISIBLE,275,410,75,20,hWnd,NULL,maininst,NULL);
   numofstepsntext=CreateWindow("STATIC","0",WS_CHILD|SS_SIMPLE|WS_VISIBLE,350,410,25,20,hWnd,NULL,maininst,NULL);

   SendMessage(framecombo,CB_ADDSTRING,0,(LPARAM)"1");
   SendMessage(framecombo,CB_ADDSTRING,0,(LPARAM)"2");
   SendMessage(framecombo,CB_ADDSTRING,0,(LPARAM)"3");
   SendMessage(framecombo,CB_ADDSTRING,0,(LPARAM)"4");
   SendMessage(framecombo,CB_ADDSTRING,0,(LPARAM)"5");
   SendMessage(framecombo,CB_ADDSTRING,0,(LPARAM)"6");
   SendMessage(framecombo,CB_ADDSTRING,0,(LPARAM)"7");
   SendMessage(framecombo,CB_ADDSTRING,0,(LPARAM)"8");
   CreatePropBox();
   CreateNewEnemBox();
   MakeEditProgBox();
   ShowWindow(hWnd,nCmdShow);
   ShowWindow(horzbar,nCmdShow);
   ShowWindow(vertbar,nCmdShow);
   ShowWindow(okbuttn,SW_SHOW);
   ShowWindow(cancelbuttn,SW_SHOW);
   SetScrollRange(horzbar,SB_CTL,0,140,true);
   SetScrollRange(vertbar,SB_CTL,0,100,true);
   DrawMenuBar(hWnd);
   //Setting up Open File Dialog thingy
    *filename=NULL;
    openfile.lStructSize = sizeof(OPENFILENAME);
    openfile.hwndOwner=hWnd;
    openfile.hInstance=hInstance;
    openfile.lpstrFilter="EBX dat file\0*.dat\0";
    openfile.lpstrCustomFilter=NULL;
    openfile.nMaxCustFilter=NULL;
    openfile.nFilterIndex=1;
    openfile.lpstrFile=filename;
    openfile.nMaxFile=500;
    openfile.lpstrFileTitle=NULL;
    openfile.nMaxFileTitle = 0;
    openfile.lpstrInitialDir=NULL;
    openfile.lpstrTitle="Open EBX data file";
    openfile.Flags=OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY;
    openfile.lpstrDefExt="dat";
   //Display crummy logo
   HDC joe=GetDC(hWnd);
   thepict=LoadDDB("C:\\EBXedit\\LOGO.bmp",joe,mypal,size);
   HDC other=CreateCompatibleDC(joe);
   SelectObject(other,thepict);
   BitBlt(joe,170,50,size->cx,size->cy,other,0,0,SRCCOPY);
   DeleteDC(other);
   ReleaseDC(hWnd,joe);
   SetTimer(hWnd,1,250,NULL);
   //message loop
   while(GetMessage(&msg,NULL,0,0))
   {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
   }
return 0;
}

LRESULT WindowProc(HWND hwnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
 switch (wMsg)
  {
   case WM_KEYDOWN:{
    if((stuffloaded)&&(editmode==MOVEMENT_MODE))
    {
    if(wParam==13)editmode=DRAGGING_MODE;
    int speed=enemies[tempselenem].speed;
    if(wParam==97){tempnewdir=DIR_DOWNLEFT;tempx-=speed;tempy+=speed;}
    if(wParam==98){tempnewdir=DIR_DOWN;tempy+=speed;}
    if(wParam==99){tempnewdir=DIR_DOWNRIGHT;tempx+=speed;tempy+=speed;}
    if(wParam==100){tempnewdir=DIR_LEFT;tempx-=speed;}
    if(wParam==101){tempnewdir=DIR_STOP;}
    if(wParam==102){tempnewdir=DIR_RIGHT;tempx+=speed;}
    if(wParam==103){tempnewdir=DIR_UPLEFT;tempx-=speed;tempy-=speed;}
    if(wParam==104){tempnewdir=DIR_UP;tempy-=speed;}
    if(wParam==105){tempnewdir=DIR_UPRIGHT;tempx+=speed;tempy-=speed;}
    if(tempnewdir!=tempdir)
     {
      tempdir=tempnewdir;
      tempmovenum++;
      movprogs[tempID].movement[tempmovenum-1]=tempnewdir;
      movprogs[tempID].framestart[tempmovenum-1]=0;
      movprogs[tempID].frameend[tempmovenum-1]=0;
      movprogs[tempID].steps[tempmovenum-1]=1;
      movprogs[tempID].numofmovs++;
     }else{
     movprogs[tempID].steps[tempmovenum-1]++;
     }

    RedrawTheThingy();
    }
    if((stuffloaded)&&(editmode==DRAGGING_MODE)&&((int)wParam==46))
    {
     if(selectenemy>-1)enemies[selectenemy].alive=false;
     if((selectimage>-1)&&(selectenemy<0))
     {
      bool dependants=false;
       for(int n=0;n<15;n++)
       {
        if((enemies[n].alive)&&(enemies[n].ImgID==selectimage))
        {
         dependants=true;
         break;
        }
       }
      if(!dependants)ImgSets[selectimage].alive=false;
      if(dependants)MessageBox(hWnd,"Image Set is in use by an enemy.  Could not delete.","Editing Action Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
     }
     RedrawTheThingy();
     selectenemy=-1;
     selectimage=-1;
    }
   }
   case WM_TIMER:{  //draw border around image sets
     if((stuffloaded)&&(selectenemy>-1))
     {
        int movindex=enemies[selectenemy].programID;
     //drawing movement line
       COLORREF color;

   color=RGB(250,(250/(movprogs[movindex].numofmovs+1))*curmove,0);
       HPEN mypen=CreatePen(PS_SOLID,1,color);
       HDC hdc=GetDC(hWnd);
       HPEN oldpen=SelectObject(hdc,mypen);
       HRGN oldrgn=SelectObject(hdc,drawrgn);
       MoveToEx(hdc,prevx,prevy,NULL);
       int n=curmove;
       {
        switch(movprogs[movindex].movement[n])
        {
         case DIR_UP:{newx=prevx;newy=prevy-movprogs[movindex].steps[n]*enemies[selectenemy].speed;LineTo(hdc,newx,newy);prevx=newx;prevy=newy;break;}
         case DIR_DOWN:{newx=prevx;newy=prevy+movprogs[movindex].steps[n]*enemies[selectenemy].speed;LineTo(hdc,newx,newy);prevx=newx;prevy=newy;break;}
         case DIR_RIGHT:{newx=prevx+movprogs[movindex].steps[n]*enemies[selectenemy].speed;newy=prevy;LineTo(hdc,newx,newy);prevx=newx;prevy=newy;break;}
         case DIR_LEFT:{newx=prevx-movprogs[movindex].steps[n]*enemies[selectenemy].speed;newy=prevy;LineTo(hdc,newx,newy);prevx=newx;prevy=newy;break;}
         case DIR_DOWNLEFT:{newx=prevx-movprogs[movindex].steps[n]*enemies[selectenemy].speed;newy=prevy+movprogs[movindex].steps[n]*enemies[selectenemy].speed;LineTo(hdc,newx,newy);prevx=newx;prevy=newy;break;}
         case DIR_DOWNRIGHT:{newx=prevx+movprogs[movindex].steps[n]*enemies[selectenemy].speed;newy=prevy+movprogs[movindex].steps[n]*enemies[selectenemy].speed;LineTo(hdc,newx,newy);prevx=newx;prevy=newy;break;}
         case DIR_UPLEFT:{newx=prevx-movprogs[movindex].steps[n]*enemies[selectenemy].speed;newy=prevy-movprogs[movindex].steps[n]*enemies[selectenemy].speed;LineTo(hdc,newx,newy);prevx=newx;prevy=newy;break;}
         case DIR_UPRIGHT:{newx=prevx+movprogs[movindex].steps[n]*enemies[selectenemy].speed;newy=prevy-movprogs[movindex].steps[n]*enemies[selectenemy].speed;LineTo(hdc,newx,newy);prevx=newx;prevy=newy;break;}
         case DIR_STOP:{Ellipse(hdc,prevx-2,prevy-2,prevx+4,prevy+4);newx=prevx;newy=prevy;break;}
        }
       }
      SelectObject(hdc,oldrgn);
      SelectObject(hdc,oldpen);
      DeleteObject(mypen);
      ReleaseDC(hWnd,hdc);
      curmove++;
      if(curmove>=movprogs[movindex].numofmovs){
       curmove=0;
       prevx=enemies[selectenemy].x+10-GetScrollPos(horzbar,SB_CTL);
       prevy=enemies[selectenemy].y+10-GetScrollPos(vertbar,SB_CTL);
      }
     }
     if(stuffloaded)
      {
        flickergreen=!flickergreen;
        if(flickergreen)color=RGB(0,250,0);
        if(!flickergreen)color=RGB(0,0,250);
        HDC surface=GetDC(hWnd);
        HRGN oldrgn=SelectObject(surface,drawrgn);
        HPEN hPen=CreatePen(PS_SOLID,1,color);
        HPEN oldpen=SelectObject(surface,hPen);
          for(int n=0;n<15;n++)
          {
          if(ImgSets[n].alive) //check if Image set exists
           {
           MoveToEx(surface,ImgSets[n].x+10-GetScrollPos(horzbar,SB_CTL),ImgSets[n].y+10-GetScrollPos(vertbar,SB_CTL)-CLIPOFFTOP,NULL);
           LineTo(surface,ImgSets[n].x+ImgSets[n].width+10-GetScrollPos(horzbar,SB_CTL)+1,ImgSets[n].y+10-GetScrollPos(vertbar,SB_CTL)-CLIPOFFTOP);
           LineTo(surface,ImgSets[n].x+ImgSets[n].width+10-GetScrollPos(horzbar,SB_CTL)+1,ImgSets[n].y+ImgSets[n].height+10-GetScrollPos(vertbar,SB_CTL)-CLIPOFFTOP+1);
           LineTo(surface,ImgSets[n].x+10-GetScrollPos(horzbar,SB_CTL),ImgSets[n].y+ImgSets[n].height+10-GetScrollPos(vertbar,SB_CTL)-CLIPOFFTOP+1);
           LineTo(surface,ImgSets[n].x+10-GetScrollPos(horzbar,SB_CTL),ImgSets[n].y+10-GetScrollPos(vertbar,SB_CTL)-CLIPOFFTOP);
           //frames
           LineTo(surface,ImgSets[n].x+ImgSets[n].width+10-GetScrollPos(horzbar,SB_CTL)+1+((ImgSets[n].width+1)*(ImgSets[n].frames-1)),ImgSets[n].y+10-GetScrollPos(vertbar,SB_CTL)-CLIPOFFTOP);
           LineTo(surface,ImgSets[n].x+ImgSets[n].width+10-GetScrollPos(horzbar,SB_CTL)+1+((ImgSets[n].width+1)*(ImgSets[n].frames-1)),ImgSets[n].y+ImgSets[n].height+11-GetScrollPos(vertbar,SB_CTL)-CLIPOFFTOP);
           LineTo(surface,ImgSets[n].x+10-GetScrollPos(horzbar,SB_CTL),ImgSets[n].y+ImgSets[n].height+11-GetScrollPos(vertbar,SB_CTL)-CLIPOFFTOP);
          }
         }
        SelectObject(surface,oldpen);
        DeleteObject(oldpen);
        DeleteObject(hPen);
        SelectObject(surface,oldrgn);
        DeleteObject(oldrgn);
        ReleaseDC(hWnd,surface);
       }
    break;
    }
   case WM_SIZE:{
    if(stuffloaded)RedrawTheThingy();
    break;
    }
   case WM_ACTIVATE:{
    if(stuffloaded)RedrawTheThingy();
    break;
    }
   case WM_CLOSE:{
      if(stuffloaded)
      {
       int testing=MessageBox(hWnd,"Would you like to save?","Dat file Loading Error",MB_YESNOCANCEL|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
       if(testing==IDYES)
       {
        openfile.lpstrTitle="Save EBX data file";
        bool joe=GetSaveFileName(&openfile);
        if(joe)
        {
        int errorchk=savedatfile(filename);
        }
       }
       if((testing==IDNO)||(testing==IDYES))
       {
       DestroyWindow(hWnd);
       quitting();
       PostQuitMessage(0);
       }
      }
      else
      {
       DestroyWindow(hWnd);
       quitting();
       PostQuitMessage(0);
      }
    break;
    }
   case WM_MOUSEMOVE:{
     for(int n=0;n<15;n++)
      {
       if((ImgSets[n].alive)&&((HIWORD(lParam)-10+GetScrollPos(vertbar,SB_CTL)+CLIPOFFTOP>ImgSets[n].y)&&(HIWORD(lParam)+GetScrollPos(vertbar,SB_CTL)-10+CLIPOFFTOP<ImgSets[n].y+ImgSets[n].height)&&(LOWORD(lParam)+GetScrollPos(horzbar,SB_CTL)-10>ImgSets[n].x+ImgSets[n].width-4)&&(LOWORD(lParam)+GetScrollPos(horzbar,SB_CTL)-10<ImgSets[n].x+ImgSets[n].width+2)))
       {
       SetCursor(sizcursor);
       }
      }
  if(editmode==IMGSIZING_MODE)
  {
  ImgSets[selectimage].width=LOWORD(lParam)-10+GetScrollPos(horzbar,SB_CTL)-ImgSets[selectimage].x;
  ImgSets[selectimage].height=HIWORD(lParam)-10+GetScrollPos(vertbar,SB_CTL)-ImgSets[selectimage].y+CLIPOFFTOP;
  RedrawTheThingy();
  }
     //if dragging
     if((mousedown)&&(selectimage!=-1)&&(stuffloaded)&&(editmode==DRAGGING_MODE)){
      if((LOWORD(lParam)>9)&&(LOWORD(lParam)<510)&&(HIWORD(lParam)>9)&&(HIWORD(lParam)<390))
      {
        ImgSets[selectimage].x=LOWORD(lParam)-10+GetScrollPos(horzbar,SB_CTL);
        ImgSets[selectimage].y=HIWORD(lParam)-10+GetScrollPos(vertbar,SB_CTL)+CLIPOFFTOP;
        RedrawTheThingy();
          char *convert=new char[25];
          char *convert2=new char[25];
           HDC hdc=GetDC(hWnd);
           RECT rect=makrect(555,242,555+150,242+22);
           FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
           rect=makrect(555,264,555+150,264+22);
           FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
           rect=makrect(595,220,595+150,220+22);
           FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
           ReleaseDC(hWnd,hdc);
          itoa(ImgSets[selectimage].x,convert,10);
          SetWindowText(xntext2,convert);
          itoa(ImgSets[selectimage].y,convert2,10);
          SetWindowText(yntext2,convert2);
          itoa(selectimage,convert2,10);
          SetWindowText(selnum2,convert2);
          delete convert2;
          delete convert;
      }

     }

     if((mousedown)&&(selectenemy!=-1)&&(selectimage==-1)&&(stuffloaded)&&(editmode==DRAGGING_MODE)){
      if((LOWORD(lParam)>9)&&(LOWORD(lParam)<510)&&(HIWORD(lParam)>9)&&(HIWORD(lParam)<390))
      {
       enemies[selectenemy].x=LOWORD(lParam)-10+GetScrollPos(horzbar,SB_CTL);
       enemies[selectenemy].y=HIWORD(lParam)-10+GetScrollPos(vertbar,SB_CTL);
       RedrawTheThingy();
         char *convert=new char[25];
         char *convert2=new char[25];
          HDC hdc=GetDC(hWnd);
          RECT rect=makrect(555,32,555+150,32+20);
          FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
          rect=makrect(555,54,555+150,32+20+22);
          FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
          rect=makrect(595,10,595+150,10+20);
          FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
          ReleaseDC(hWnd,hdc);
         itoa(enemies[selectenemy].x,convert,10);
         SetWindowText(xntext,convert);
         itoa(enemies[selectenemy].y,convert2,10);
         SetWindowText(yntext,convert2);
         itoa(selectenemy,convert2,10);
         SetWindowText(selnum,convert2);
         delete convert2;
         delete convert;
      }
     }
     break;
    } //end of mouse move
   case WM_RBUTTONUP:
   case WM_LBUTTONUP:{
     mousedown=false;
     if(editmode==IMGSIZING_MODE)
     {
     editmode=DRAGGING_MODE;
     }
     break;
   }
   case WM_RBUTTONDOWN:
   case WM_LBUTTONDOWN:{  //if they click
      //Check if clicked on a Image Set
      SetFocus(hWnd);
     if((stuffloaded)&&(editmode==DRAGGING_MODE))
     {
      if(wMsg==WM_LBUTTONDOWN)mousedown=true;
      int bx=LOWORD(lParam);
      int by=HIWORD(lParam);
      for(int n=0;n<15;n++)
      {
       if((ImgSets[n].alive)&&(ImgSets[n].x<bx-10+GetScrollPos(horzbar,SB_CTL))&&(ImgSets[n].y<by-10+GetScrollPos(vertbar,SB_CTL)+CLIPOFFTOP)&&(ImgSets[n].width+ImgSets[n].x>bx-10+GetScrollPos(horzbar,SB_CTL))&&(ImgSets[n].height+ImgSets[n].y>by-10+GetScrollPos(vertbar,SB_CTL)+CLIPOFFTOP))
        {
         selectimage=n;
         break;
        }
       if(n>=14)selectimage=-1;
      }
     }
     //check if clicked on enemy
     if((stuffloaded)&&(editmode==DRAGGING_MODE))
     {
      if(wMsg==WM_LBUTTONDOWN)mousedown=true;
      int bx=LOWORD(lParam);
      int by=HIWORD(lParam);
      for(int n=0;n<curenem;n++)
      {
       if((enemies[n].x<bx-10+GetScrollPos(horzbar,SB_CTL))&&(enemies[n].y<by-10+GetScrollPos(vertbar,SB_CTL))&&(ImgSets[enemies[n].ImgID].width+enemies[n].x>bx-10+GetScrollPos(horzbar,SB_CTL))&&(ImgSets[enemies[n].ImgID].height+enemies[n].y>by-10+GetScrollPos(vertbar,SB_CTL)))
        {
         selectenemy=n;
         break;
        }
       if(n>=curenem-1)selectenemy=-1;
      }
     }
     if((stuffloaded)&&(editmode==DRAGGING_MODE))
     {
       RedrawTheThingy();
//image set numbers
         char *convert=new char[25];
         char *convert2=new char[25];
         {   HDC hdc=GetDC(hWnd);
            RECT rect=makrect(555,242,555+150,242+22);
            FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
            rect=makrect(555,264,555+150,264+22);
            FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
            rect=makrect(595,220,595+150,220+22);
            FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
            ReleaseDC(hWnd,hdc);
         if(selectimage>-1)
          {
           itoa(ImgSets[selectimage].x,convert,10);
           SetWindowText(xntext2,convert);
           itoa(ImgSets[selectimage].y,convert2,10);
           SetWindowText(yntext2,convert2);
           itoa(selectimage,convert2,10);
           SetWindowText(selnum2,convert2);
           SendMessage(framecombo,CB_SETCURSEL,ImgSets[selectimage].frames-1,0);
          }
         }
//enemy numbers
        {    HDC hdc=GetDC(hWnd);
            RECT rect=makrect(555,32,555+150,32+20);
            FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
            rect=makrect(555,54,555+150,32+20+22);
            FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
            rect=makrect(595,10,595+150,10+20);
            FillRect(hdc,&rect,(HBRUSH)COLOR_WINDOW);
            SetWindowText(progedit,NULL);
            SetWindowText(epedit,NULL);
            SetWindowText(HPedit,NULL);
            SetWindowText(speededit2,NULL);
            SetWindowText(aniredit,NULL);
            ReleaseDC(hWnd,hdc);
        if(selectenemy>-1)
          {
           itoa(enemies[selectenemy].programID,convert,10);
           SetWindowText(progedit,convert);
           itoa(enemies[selectenemy].ImgID,convert,10);
           SetWindowText(epedit,convert);
           itoa(enemies[selectenemy].x,convert,10);
           SetWindowText(xntext,convert);
           itoa(enemies[selectenemy].y,convert2,10);
           SetWindowText(yntext,convert2);
           itoa(selectenemy,convert2,10);
           SetWindowText(selnum,convert2);
           itoa(enemies[selectenemy].HP,convert2,10);
           SetWindowText(HPedit,convert2);
           itoa(enemies[selectenemy].speed,convert2,10);
           SetWindowText(speededit2,convert2);
           itoa(enemies[selectenemy].anirate,convert2,10);
           SetWindowText(aniredit,convert2);
          }
         }

      if(selectimage==-1)
      {
        SetWindowText(selnum2,"NONE");
      }
      if(selectenemy==-1)
      {
         SetWindowText(selnum,"NONE");
      }
     }
     for(int n=0;n<15;n++)
      {
       if((ImgSets[n].alive)&&(HIWORD(lParam)-10+GetScrollPos(vertbar,SB_CTL)+CLIPOFFTOP>ImgSets[n].y)&&(HIWORD(lParam)+GetScrollPos(vertbar,SB_CTL)-10+CLIPOFFTOP<ImgSets[n].y+ImgSets[n].height)&&(LOWORD(lParam)+GetScrollPos(horzbar,SB_CTL)-10>ImgSets[n].x+ImgSets[n].width-4)&&(LOWORD(lParam)+GetScrollPos(horzbar,SB_CTL)-10<ImgSets[n].x+ImgSets[n].width+2))
       {
       editmode=IMGSIZING_MODE;
       selectimage=n;
       SetCursor(sizcursor);
       break;
       }
      }

    break;
    }
   case WM_HSCROLL:{
   if(stuffloaded)
    {
     int abcd=HIWORD(wParam);
     if(LOWORD(wParam)==SB_THUMBTRACK)xpos=abcd;
     if((LOWORD(wParam)==SB_LINELEFT)&&(xpos>0))xpos--;
     if((LOWORD(wParam)==SB_LINERIGHT)&&(xpos<140))xpos++;
     if(LOWORD(wParam)==SB_PAGELEFT){
        if(xpos<15){
        xpos=0;}
        else {xpos-=15;}}
     if((LOWORD(wParam)==SB_PAGERIGHT)){
        if(xpos>125){
        xpos=140;}
        else {xpos+=15;}}
     SetScrollPos(horzbar,SB_CTL,xpos,true);
     RedrawTheThingy();
    }
     break;
    }

   case WM_VSCROLL:{
   if(stuffloaded)
    {
     int abcd=HIWORD(wParam);
     if(LOWORD(wParam)==SB_THUMBTRACK)ypos=abcd;
     if((LOWORD(wParam)==SB_LINEUP)&&(ypos>0))ypos--;
     if((LOWORD(wParam)==SB_LINEDOWN)&&(ypos<(size->cy-CLIPOFFTOP-380)))ypos++;
     if(LOWORD(wParam)==SB_PAGEUP){
        if(ypos<15){
        ypos=0;}
        else {ypos-=15;}}
     if((LOWORD(wParam)==SB_PAGEDOWN)){
        if(ypos>(size->cy-CLIPOFFTOP-385)){
        ypos=size->cy-CLIPOFFTOP-385;}
        else {ypos+=15;}}
     SetScrollPos(vertbar,SB_CTL,ypos,true);
     RedrawTheThingy();
    }
     break;
    }

  case WM_COMMAND:{
   if((stuffloaded)&&(editmode==DRAGGING_MODE)&&(selectenemy>-1)&&(HIWORD(wParam)==EN_KILLFOCUS))
   {
   char abc[25];
   GetWindowText((HWND)lParam,(char*)&abc,25);
   int fifrules=atoi((char*)&abc);
   if((lParam==(LPARAM)progedit)&&(movprogs[fifrules].alive))enemies[selectenemy].programID=fifrules;
   if((lParam==(LPARAM)epedit)&&(ImgSets[fifrules].alive))enemies[selectenemy].ImgID=fifrules;
   if(lParam==(LPARAM)HPedit)enemies[selectenemy].HP=fifrules;
   if(lParam==(LPARAM)speededit2)enemies[selectenemy].speed=fifrules;
   if(lParam==(LPARAM)aniredit)enemies[selectenemy].anirate=fifrules;
   }
      if((stuffloaded)&&((HWND)lParam==framecombo)&&(editmode==DRAGGING_MODE))
      {
       if(selectimage>-1)ImgSets[selectimage].frames=SendMessage(framecombo,CB_GETCURSEL,0,0)+1;
       RedrawTheThingy();
      }
     if((LOWORD(wParam)==MENUEDITMOVE)&&(stuffloaded)&&(editmode==DRAGGING_MODE))
      {
      SendMessage(IDcombo,CB_RESETCONTENT,0,0);
      for(int n=0;n<15;n++)
       {
       char lalala[15];
       itoa(n,(char*)&lalala,10);
       if(movprogs[n].alive)SendMessage(IDcombo,CB_ADDSTRING,0,(LPARAM)&lalala);
       }
       ShowWindow(moveeditbox,SW_SHOW);
      }
      if((LOWORD(wParam)==MENUNEWIMGSET)&&(stuffloaded)&&(editmode==DRAGGING_MODE))
      {
       int n; bool found=false;
       for(n=0;n<15;n++)
       {
        if(!ImgSets[n].alive)  //find empty image set to place new one in;
        {
         ImgSets[n].alive=true;  ImgSets[n].x=1; ImgSets[n].y=1+CLIPOFFTOP; ImgSets[n].width=40;  ImgSets[n].height=50;  ImgSets[n].frames=2;  ImgSets[n].ID=n;
         found=true;
         break;
        }
       }
       if(!found)MessageBox(hWnd,"Too many Image sets already.","Image Set Creation Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
      }
      if(LOWORD(wParam)==MENUEXITID)
      {
      if(stuffloaded)
      {
       int testing=MessageBox(hWnd,"Would you like to save?","Dat file Loading Error",MB_YESNOCANCEL|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
       if(testing==IDYES)
       {
        openfile.lpstrTitle="Save EBX data file";
        bool joe=GetSaveFileName(&openfile);
        if(joe)
        {
        int errorchk=savedatfile(filename);
        }
       }
       if((testing==IDNO)||(testing==IDYES))
       {
       DestroyWindow(hWnd);
       quitting();
       PostQuitMessage(0);
       }
      }
      else
      {
       DestroyWindow(hWnd);
       quitting();
       PostQuitMessage(0);
      }
      }
      if((LOWORD(wParam)==MENUNEWENEMID)&&(stuffloaded)&&(editmode==DRAGGING_MODE))  //new enemy menu item
      {

       SendMessage(imageid,CB_RESETCONTENT,0,0);
       SendMessage(progid,CB_RESETCONTENT,0,0);
       for(int n=0;n<15;n++)
       {
        char convert[15];
        itoa(n,(char*)&convert,10);
        if(ImgSets[n].alive)SendMessage(imageid,CB_ADDSTRING,0,(LPARAM)&convert);
        if(movprogs[n].alive)SendMessage(progid,CB_ADDSTRING,0,(LPARAM)&convert);
       }
        if(SendMessage(imageid,CB_GETCOUNT,0,0)==0)
        {
         MessageBox(hWnd,"No image sets created yet.  Create an image set first.","Dat file Loading Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
         break;
        }
        if(SendMessage(progid,CB_GETCOUNT,0,0)==0)
        {
         MessageBox(hWnd,"No Movements created yet.  Create a movement program first.","Dat file Loading Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
         break;
        }

      SendMessage(imageid,CB_SETCURSEL,0,0);
      SendMessage(progid,CB_SETCURSEL,0,0);
      ShowWindow(enemybox,SW_SHOW);
      }

      if((LOWORD(wParam)==MENUPROPID)&&(stuffloaded))   //level properties menu item
      {
      SetWindowText(edit1,HEADR.message);
      SetWindowText(edit2,HEADR.title);
      SetWindowText(edit3,HEADR.bmppath);
      SetWindowText(edit4,HEADR.BGM);
      SetWindowText(edit5,HEADR.WIN);
      SetWindowText(edit6,HEADR.ONEUP);
      SetWindowText(edit7,HEADR.LOSE);
      SetWindowText(edit8,HEADR.END);
      char *convert=new char[25];
      SetWindowText(edit9,itoa(HEADR.bonus,convert,10));
      delete convert;
      ShowWindow(headrbox,SW_SHOW);
      }

      if((LOWORD(wParam)==MENUSAVEID)&&(stuffloaded))
      {
       openfile.lpstrTitle="Save EBX data file";
       bool joe=GetSaveFileName(&openfile);
       if(joe)
       {
       int errorchk=savedatfile(filename);
       }
       break;
      }

      if(LOWORD(wParam)==MENUOPENID)       //Open menu item
      {
       openfile.lpstrTitle="Open EBX data file";
       bool joe=GetOpenFileName(&openfile);
       if(joe)
        {
         //check if there were reading errors
         strcpy(filenamebackup,filename);
         int errorchk=readdatfile(filename);
         switch(errorchk){
           case YNNNPROBLEM:
              MessageBox(hWnd,"Line 10 did not=\"Y N N N\"","Dat file Loading Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
              break;
           case ENDTOOSOON:
              MessageBox(hWnd,"File ended before expected","Dat file Loading Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
              break;
           case BMPNOTFOUND:
              MessageBox(hWnd,"Error reading .bmp.  Make sure the directory specified in the file is correct.","Dat file Loading Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
              break;
           case NOREALWORD:
              MessageBox(hWnd,"Inncorrect syntax in .dat file","Dat file Loading Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
              break;
           case LOADEDOK:
              RedrawTheThingy();
              break;
             }//end errorchk switch statement
        }//end Openfile

      }//end MENUOPEN

     if((stuffloaded)&&(LOWORD(wParam)==MENUNEWMOVEMENT)&&(editmode==DRAGGING_MODE))
     {
      if(selectenemy>-1)
      {
      editmode=MOVEMENT_MODE;
      tempselenem=selectenemy;
      tempx=enemies[selectenemy].x;
      tempy=enemies[selectenemy].y;
      tempmovenum=0;
      tempdir=0;
      tempnewdir=0;
    int yadda=-1;
    for(int n=0;n<15;n++)
    {
     if(!movprogs[n].alive){yadda=n;break;}
    }
    if(yadda!=-1)
    {
     movprogs[yadda].alive=true;
     movprogs[yadda].numofmovs=0;
     enemies[selectenemy].programID=yadda;
     tempID=yadda;
      HDC Hdc=GetDC(hWnd);
      RECT rect=makrect(200,410,200+50,410+22);
      FillRect(Hdc,&rect,(HBRUSH)COLOR_WINDOW);
      ReleaseDC(hWnd,Hdc);
     char abcd[10];
     itoa(tempID,(char*)&abcd,10);
     SetWindowText(editprogntext,(char*)&abcd);
    }else MessageBox(hWnd,"No empty movement programs.  Please delete one.","Movement editing Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
      }
      else MessageBox(hWnd,"No Enemy Selected.  Must have an enemy selected for this action.","Movement editing Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
     }
   }//end WM_COMMAND
  default: return DefWindowProc(hwnd, wMsg, wParam, lParam);
 }
}



void quitting(void)
{
delete HEADR.message;
delete HEADR.title;
delete HEADR.bmppath;
delete HEADR.BGM;
delete HEADR.WIN;
delete HEADR.ONEUP;
delete HEADR.LOSE;
delete HEADR.END;
delete filename;
DeleteObject(*mypal);
delete mypal;
delete size;
delete filenamebackup;
DestroyWindow(headrbox);
KillTimer(hWnd,1);
delete iconvert;
delete iconvert2;
}

RECT makrect(int x,int y, int a, int b)
{
 RECT rect;
 rect.left=x;
 rect.top=y;
 rect.right=a;
 rect.bottom=b;
 return rect;
}

RECT* makrectp(int x,int y, int a, int b)
{
 RECT *rect=new RECT;
 rect->left=x;
 rect->top=y;
 rect->left=a;
 rect->bottom=b;
 return rect;
}

HBITMAP LoadDDB(char *name,HDC context,HPALETTE *hPal,SIZE *size)
{
    BITMAPFILEHEADER headr;
    BITMAPINFOHEADER infoh;


     const maxread = 45*1024;
     unsigned int numcolors=0;
    ifstream *ifs=new ifstream(name,ios::in|ios::binary);
    if(*ifs)
    {
     ifs->read((char*)&headr,sizeof(BITMAPFILEHEADER));
     if((LOBYTE(headr.bfType)!='B')||(HIBYTE(headr.bfType!='M')))return NULL;
     ifs->read((char*)&infoh,sizeof(BITMAPINFOHEADER));
     infoh.biWidth=infoh.biWidth;
     infoh.biClrImportant=0;
    if(infoh.biClrUsed!=0){numcolors=infoh.biClrUsed;}
    else
    {
    switch(infoh.biBitCount){
    case 1: {numcolors=2;}
    case 4: {numcolors=16;}
    case 8: {numcolors=256;}
    default: {numcolors=0;}
    }


    }
     LPBITMAPINFO info1;
     info1 = (LPBITMAPINFO) new BYTE[sizeof(BITMAPINFOHEADER)+(numcolors * sizeof(RGBQUAD))];
     ifs->seekg(sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER));
     ifs->read((char*)info1->bmiColors,numcolors*sizeof(RGBQUAD));
     info1->bmiHeader=infoh;
     unsigned long bmpsize=headr.bfSize;
     bmpsize=bmpsize-sizeof(BITMAPFILEHEADER);
     void far *data=new BYTE[bmpsize];
     LOGPALETTE far *logpal;
     logpal = (LPLOGPALETTE) new BYTE[(numcolors*sizeof(RGBQUAD))+sizeof(LOGPALETTE)];
     logpal->palVersion=0x0300;
     logpal->palNumEntries=numcolors;
     for(int n=0;n<numcolors;n++)
     {
       info1->bmiColors[n].rgbReserved=0;
     }

     for(unsigned int n=0;n<numcolors;n++)
       {
         logpal->palPalEntry[n].peRed=info1->bmiColors[n].rgbRed;
         logpal->palPalEntry[n].peBlue=info1->bmiColors[n].rgbBlue;
         logpal->palPalEntry[n].peGreen=info1->bmiColors[n].rgbGreen;
         logpal->palPalEntry[n].peFlags=PC_NOCOLLAPSE;
       }
    *hPal = CreatePalette(logpal);

    ifs->seekg(headr.bfOffBits,ios::beg);
    unsigned int chunk;
    unsigned int prevbmpsize=bmpsize;
    while(bmpsize>0)
    {
            if(bmpsize>=maxread)chunk=maxread;
            else chunk=bmpsize;
            ifs->read((char*)data, chunk);
            bmpsize-=chunk;
            (char*)data+=chunk;
    }
    (char*)data-=prevbmpsize;


     ifs->close();
     HBITMAP mybmp;
     size->cx=infoh.biWidth;
     size->cy=infoh.biHeight;
     mybmp=CreateDIBitmap(context,&infoh,CBM_INIT,data,info1,DIB_RGB_COLORS);
      delete info1;
      delete data;
      delete ifs;
      delete logpal;
     return mybmp;
    }
delete ifs;
return NULL;
}

int savedatfile(char *datfilename)
{
char enterkey=10;
char *convert=new char[100];
ofstream *datfile=new ofstream(datfilename,ios::out);
 //write header
 datfile->write(HEADR.message,strlen(HEADR.message));
 datfile->write(&enterkey,1); //enter key
 datfile->write(HEADR.title,strlen(HEADR.title));
 datfile->write(&enterkey,1);
 datfile->write(HEADR.bmppath,strlen(HEADR.bmppath));
 datfile->write(&enterkey,1);
 datfile->write(HEADR.BGM,strlen(HEADR.BGM));
 datfile->write(&enterkey,1);
 datfile->write(HEADR.WIN,strlen(HEADR.WIN));
 datfile->write(&enterkey,1);
 datfile->write(HEADR.ONEUP,strlen(HEADR.ONEUP));
 datfile->write(&enterkey,1);
 datfile->write(HEADR.LOSE,strlen(HEADR.LOSE));
 datfile->write(&enterkey,1);
 datfile->write(HEADR.END,strlen(HEADR.END));
 datfile->write(&enterkey,1);
  itoa(HEADR.bonus,convert,10);  //converting bonus to string
 datfile->write(convert,strlen(convert));
 datfile->write(&enterkey,1);
  datfile->write("Y N N N",7);  //place Y N N N in file
  datfile->write(&enterkey,1);
  datfile->write(&enterkey,1);  //put a blank line after header for tidiness

  for(int n=0;n<15;n++)
  {
   if(movprogs[n].alive)
   {
      datfile->write("BEP ",4);
      itoa(n,convert,10);
      datfile->write(convert,strlen(convert));
      datfile->write(&enterkey,1);  //hit return

    for(int m=0;m<movprogs[n].numofmovs;m++)
    {
     if(movprogs[n].movement[m]==DIR_UP)datfile->write(" UP ",4);
     if(movprogs[n].movement[m]==DIR_DOWN)datfile->write(" DOWN ",6);
     if(movprogs[n].movement[m]==DIR_LEFT)datfile->write(" LEFT ",6);
     if(movprogs[n].movement[m]==DIR_RIGHT)datfile->write(" RIGHT ",7);
     if(movprogs[n].movement[m]==DIR_UPRIGHT)datfile->write(" UPRIGHT ",9);
     if(movprogs[n].movement[m]==DIR_UPLEFT)datfile->write(" UPLEFT ",8);
     if(movprogs[n].movement[m]==DIR_DOWNRIGHT)datfile->write(" DOWNRIGHT ",11);
     if(movprogs[n].movement[m]==DIR_DOWNLEFT)datfile->write(" DOWNLEFT ",10);
     if(movprogs[n].movement[m]==DIR_STOP)datfile->write(" STOP ",6);
    itoa(movprogs[n].steps[m],convert,10);
     datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(movprogs[n].framestart[m],convert,10);
     datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(movprogs[n].frameend[m],convert,10);
     datfile->write(convert,strlen(convert)); datfile->write(" ",1);
     datfile->write(&enterkey,1);  //hit return

     }
     datfile->write("EEP",3);
     datfile->write(&enterkey,1);  //hit return
   }
  }
datfile->write(&enterkey,1);  //hit return
  for(int n=0;n<=curenem;n++)
  {
   if(enemies[n].alive)
   {
    datfile->write("ENEMY ",6);
    itoa(enemies[n].programID,convert,10);   //writes the enemy's program ID
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(enemies[n].speed,convert,10);    //writes the enemy speed
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(enemies[n].anirate,convert,10);     //writes anirate
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(enemies[n].HP,convert,10);  //writes HP
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(enemies[n].x,convert,10);   //writes Xpos
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(enemies[n].y,convert,10);
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(enemies[n].ImgID,convert,10);
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    datfile->write(&enterkey,1);  //hit return
    }
  }
datfile->write(&enterkey,1);
  for(int n=0;n<15;n++)
  {
   if(ImgSets[n].alive)
   {
    datfile->write("CIS ",4);
    itoa(ImgSets[n].x,convert,10);
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(ImgSets[n].y,convert,10);
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(ImgSets[n].width,convert,10);
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(ImgSets[n].height,convert,10);
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(ImgSets[n].frames,convert,10);
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    itoa(n,convert,10);
    datfile->write(convert,strlen(convert)); datfile->write(" ",1);
    datfile->write(&enterkey,1);  //hit return
   }
  }

datfile->write(&enterkey,1);
datfile->write("END",3);
datfile->write(&enterkey,1);
datfile->write(&enterkey,1);
datfile->write(" ---edited in spaanoft's EBX level editor--- ",45);  //a fingerprint
datfile->close();
delete convert;
delete datfile;
return 0;
}


int readdatfile(char *datfilename) //reads in and interprets .dat file
{
   for(int n=0;n<15;n++)
   {
   enemies[n].alive=false;
   }
   for(int n=0;n<15;n++)
   {
   movprogs[n].alive=false;
   }
   for(int n=0;n<15;n++)
   {
   ImgSets[n].alive=false;
   }
 stuffloaded=false;
 xpos=0;
 ypos=0;
 curenem=0;
 char *thebmppath;
 ifstream *datfile=new ifstream(datfilename,ios::in|ios::binary);
 //reading header
 directory=getdirfromstr(datfilename);
 HEADR.message=readln(datfile);
  if(*HEADR.message==(char)ENDTOOSOON)return ENDTOOSOON;
 HEADR.title=readln(datfile);
  if(*HEADR.title==(char)ENDTOOSOON)return ENDTOOSOON;
 HEADR.bmppath=readln(datfile);
      thebmppath=strcat(directory,HEADR.bmppath);
      HDC Hdc=GetDC(hWnd);
      DeleteObject(thepict);
      thepict=LoadDDB(thebmppath,Hdc,mypal,size);
      if(!thepict){datfile->close();delete datfile; return BMPNOTFOUND;}
      SelectPalette(Hdc,mypal,true);
      RealizePalette(Hdc);
      SetScrollRange(vertbar,SB_CTL,0,size->cy-380-CLIPOFFTOP,true);
      HDC other=CreateCompatibleDC(Hdc);
      SelectObject(other,thepict);
      BitBlt(Hdc,10,10,500,380,other,0,197,SRCCOPY);
      ReleaseDC(hWnd,Hdc);
      DeleteDC(other);
  if(*HEADR.bmppath==(char)ENDTOOSOON){datfile->close();delete datfile; return ENDTOOSOON;}
 HEADR.BGM=readln(datfile);
  if(*HEADR.BGM==(char)ENDTOOSOON){datfile->close();delete datfile; return ENDTOOSOON;}
 HEADR.WIN=readln(datfile);
  if(*HEADR.WIN==(char)ENDTOOSOON){datfile->close();delete datfile; return ENDTOOSOON;}
 HEADR.ONEUP=readln(datfile);
  if(*HEADR.ONEUP==(char)ENDTOOSOON){datfile->close();delete datfile; return ENDTOOSOON;}
 HEADR.LOSE=readln(datfile);
  if(*HEADR.LOSE==(char)ENDTOOSOON){datfile->close();delete datfile; return ENDTOOSOON;}
 HEADR.END=readln(datfile);
  if(*HEADR.END==(char)ENDTOOSOON){datfile->close();delete datfile; return ENDTOOSOON;}
 HEADR.bonus=atoi(readln(datfile));
 HEADR.YNNN=readln(datfile);
 if(strcmp(HEADR.YNNN,"Y N N N")!=0){
 SetWindowText(hWnd,"EBX Level Editor");
   return YNNNPROBLEM;
  }
 //done reading header.  Begin reading other stuff
 bool hitend=false;
 char *temp1;
 char *temp2=new char[500];
 signed int movpntr=0;
 while(!hitend) //read until hitting 'END'
  {
   temp1=readln(datfile);
    movpntr=readword(temp1,temp2);
   if((*temp1==(char)ENDTOOSOON)&&(strcmp(temp2,"END")!=1)){datfile->close();delete datfile; return ENDTOOSOON;}
   if(movpntr<(-1)){datfile->close();delete datfile; return NOREALWORD;}
   temp1+=movpntr;
   if(strcmp(temp2,"END")==0)hitend=true;
   if(strcmp(temp2,"BEP")==0)
       {
        int prognum;
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
        temp1+=movpntr;
        prognum=atoi(temp2);
        movprogs[prognum].alive=true;
        bool hiteep=false;
        int count=0;

         while(!hiteep)//Loop to read in until it hits an "EEP"
         {
         char *temp3=new char[150];
         char *temp4=new char[100];

          bool foundcom=false;
          temp3=readln(datfile);
          movpntr=readword(temp3,temp4);
//          if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
          temp3+=movpntr;
          //Checking what command was read in
           if(strcmp(temp4,"EEP")==0){hiteep=true;}
           else
           {
           if(strcmp(temp4,"UP")==0){movprogs[prognum].movement[count]=DIR_UP;foundcom=true;}
           if(strcmp(temp4,"DOWN")==0){movprogs[prognum].movement[count]=DIR_DOWN;foundcom=true;}
           if(strcmp(temp4,"LEFT")==0){movprogs[prognum].movement[count]=DIR_LEFT;foundcom=true;}
           if(strcmp(temp4,"RIGHT")==0){movprogs[prognum].movement[count]=DIR_RIGHT;foundcom=true;}
           if(strcmp(temp4,"UPRIGHT")==0){movprogs[prognum].movement[count]=DIR_UPRIGHT;foundcom=true;}
           if(strcmp(temp4,"UPLEFT")==0){movprogs[prognum].movement[count]=DIR_UPLEFT;foundcom=true;}
           if(strcmp(temp4,"DOWNRIGHT")==0){movprogs[prognum].movement[count]=DIR_DOWNRIGHT;foundcom=true;}
           if(strcmp(temp4,"DOWNLEFT")==0){movprogs[prognum].movement[count]=DIR_DOWNLEFT;foundcom=true;}
           if(strcmp(temp4,"STOP")==0){movprogs[prognum].movement[count]=DIR_STOP;foundcom=true;}
          //what happens if command found
            if(foundcom)
            {
            movpntr=readword(temp3,temp4);
             if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
             temp3+=movpntr;
             movprogs[prognum].steps[count]=atoi(temp4);
            movpntr=readword(temp3,temp4);
             if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
             temp3+=movpntr;
             movprogs[prognum].framestart[count]=atoi(temp4);
            movpntr=readword(temp3,temp4);
             if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
             temp3+=movpntr;
             movprogs[prognum].frameend[count]=atoi(temp4);
             count++;
             }
             movprogs[prognum].numofmovs=count;
             }
         }

        }
   if(strcmp(temp2,"CIS")==0)  //if an Image Set sets ImgSet[IDnumber] stuff
       {
        int ax;
        int ay;
        int awidth;
        int aheight;
        int aframes;
        int arrnum;
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         ax=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         ay=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         awidth=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         aheight=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         aframes=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         arrnum=atoi(temp2);
        ImgSets[arrnum].alive=true;
        ImgSets[arrnum].ID=arrnum;
        ImgSets[arrnum].x=ax;
        ImgSets[arrnum].y=ay;
        ImgSets[arrnum].width=awidth;
        ImgSets[arrnum].height=aheight;
        ImgSets[arrnum].frames=aframes;
        }
   if(strcmp(temp2,"ENEMY")==0) //if ENEMY command fills the lowest unoccupied enemies[]
       {
         enemies[curenem].alive=true;
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         enemies[curenem].programID=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         enemies[curenem].speed=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         enemies[curenem].anirate=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         enemies[curenem].HP=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         enemies[curenem].x=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         enemies[curenem].y=atoi(temp2);
        movpntr=readword(temp1,temp2);
        if(movpntr==NOREALWORD){datfile->close();delete datfile; return NOREALWORD;}
         temp1+=movpntr;
         enemies[curenem].ImgID=atoi(temp2);

         curenem++;
       }
   }
SetWindowText(hWnd,HEADR.title);
//char *textchange=new char[50];
//SetWindowText(hWnd,itoa(enemies[0].speed,textchange,10));

 datfile->close();
 delete datfile;
 stuffloaded=true;
 return LOADEDOK;
}

char *readln(ifstream *input)  //Reads up to 500 chars to next \n character
{
 bool keepread=true;
 char *hi=new char[200];
 int place=0;
 int joe=input->tellg();
 input->seekg(0,ios::end);
 int howbig=input->tellg()-joe;
 input->seekg(joe,ios::beg);
 while(keepread)
  {
   input->read((hi+place),1);
   if(*(hi+place)=='\n')keepread=false;
   if((place>=howbig)||(place>=500))keepread=false;
   if((keepread)&&(place<howbig)&&(place<500))place++;
//  if((keepread)&&((place>=howbig)||(place>=500)))keepread=false;
  }
  if(place>0){*(hi+place-1)=CHAR(0);}
  else{
     *hi=NULL;
     return hi;
      }
  //if file ended
  if(place>=howbig){
   char *blah=new char;
   if(strcmp(hi,"EN")==0){blah="END";}
   else{*blah=(char)ENDTOOSOON;}
   return blah;
   }
 return hi;
}

signed int readword(char *myline,char *thatword) //ignores leading whitespace and reads all chars up to next whitespace and places it in *thatword and sets *myline to the next whitespace or whatever
{
 int whatnot=0;
 int place=0;
 if(*myline==NULL)return NOREALWORD;
 while((*myline==' ')||(*myline=='\t'))
  {
   myline++;
   if((*myline=='\n')||(*myline=='\0'))return NOREALWORD;
   whatnot++;
  }
 if((*myline=='\n')||(*myline=='\0'))return NOREALWORD;
 while((*myline!=' ')&&(*myline!='\t')&&(*myline!='\n')&&(*myline!='\0'))
  {
   *(thatword+place)=*myline;
   myline++;
   whatnot++;
   place++;
   if(place>=499)break;
  }
  *(thatword+place)='\0';
  return whatnot;
}

char *getdirfromstr(char *fileloc)  //clears a filename from a path and returns the pointer
{
 //find end of string
 char *booka=fileloc;
 while(*fileloc!='\0')
 {
  fileloc++;
 }

 while(*fileloc!='\\')
 {
  fileloc--;
 }
 fileloc++;
 *fileloc='\0';
 return booka;
}

void RedrawTheThingy(void)
{
      curmove=0;
      prevx=enemies[selectenemy].x+10-GetScrollPos(horzbar,SB_CTL);
      prevy=enemies[selectenemy].y+10-GetScrollPos(vertbar,SB_CTL);
     HDC Hdc=GetDC(hWnd);
     HDC other=CreateCompatibleDC(Hdc);
     HBITMAP oldbmp=SelectObject(other,thepict);
     RECT rect=makrect(350,410,350+100,410+22);
     FillRect(Hdc,&rect,(HBRUSH)COLOR_WINDOW);
     HRGN oldrgn=SelectObject(Hdc,drawrgn);
     BitBlt(Hdc,10,10,500,380,other,GetScrollPos(horzbar,SB_CTL),GetScrollPos(vertbar,SB_CTL)+197,SRCCOPY);
     for(int n=0;n<curenem;n++)
      {
       if(enemies[n].alive)
       {
        if(ImgSets[enemies[n].ImgID].alive)
        {
         BitBlt(Hdc,enemies[n].x-GetScrollPos(horzbar,SB_CTL)+10,enemies[n].y-GetScrollPos(vertbar,SB_CTL)+10,ImgSets[enemies[n].ImgID].width+2,ImgSets[enemies[n].ImgID].height+2,other,ImgSets[enemies[n].ImgID].x,ImgSets[enemies[n].ImgID].y,SRCCOPY);
        }
       }
      }
     if(editmode==MOVEMENT_MODE)
     {
     BitBlt(Hdc,tempx-GetScrollPos(horzbar,SB_CTL)+10,tempy-GetScrollPos(vertbar,SB_CTL)+10,ImgSets[enemies[tempselenem].ImgID].width+2,ImgSets[enemies[tempselenem].ImgID].height+2,other,ImgSets[enemies[tempselenem].ImgID].x,ImgSets[enemies[tempselenem].ImgID].y,SRCCOPY);
     char abcd[10];
     itoa(movprogs[tempID].steps[tempmovenum-1],(char*)&abcd,10);
     SetWindowText(numofstepsntext,(char*)&abcd);
     }
     SelectObject(other,oldbmp);
     DeleteObject(oldbmp);
     SelectObject(Hdc,oldrgn);
     DeleteObject(oldrgn);
     ReleaseDC(hWnd,Hdc);
     DeleteDC(other);
}

LRESULT hbproc(HWND hwnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
 switch(wMsg)
 {
  case WM_COMMAND:{
   if(lParam==(LPARAM)cancelbuttn)ShowWindow(headrbox,SW_HIDE);
   if(lParam==(LPARAM)okbuttn)
    {
     GetWindowText(edit1,HEADR.message,200);
     GetWindowText(edit2,HEADR.title,200);
     GetWindowText(edit3,HEADR.bmppath,200);
     DeleteObject(thepict);
     HDC ARRRRGGGG=GetDC(hWnd);
     thepict=LoadDDB(HEADR.bmppath,ARRRRGGGG,mypal,size);
     SetScrollRange(vertbar,SB_CTL,0,size->cy-380-CLIPOFFTOP,true);
     ReleaseDC(hWnd,ARRRRGGGG);
     GetWindowText(edit4,HEADR.BGM,200);
     GetWindowText(edit5,HEADR.WIN,200);
     GetWindowText(edit6,HEADR.ONEUP,200);
     GetWindowText(edit7,HEADR.LOSE,200);
     GetWindowText(edit8,HEADR.END,200);
     char *tempstr=new char[25];
     GetWindowText(edit9,tempstr,25);
     HEADR.bonus=atoi(tempstr);
     delete tempstr;
     SetWindowText(hWnd,HEADR.title);
     RedrawTheThingy();
     ShowWindow(headrbox,SW_HIDE);
    }
   break;
   }

  default:return DefWindowProc(hwnd, wMsg, wParam, lParam);
 }
}

void CreatePropBox(void)
{
   headrbox=CreateWindowEx(WS_EX_TOOLWINDOW|WS_EX_TOPMOST,
                          "Header Props",
                          "Level Properties",
                          WS_OVERLAPPED|WS_SIZEBOX,
                         (workarea.right/2-260)+50,(workarea.bottom/2-175)+50,
                          520,350,
                          NULL,
                          NULL,
                          maininst,
                          NULL);

   okbuttn=CreateWindow("BUTTON","OK",BS_PUSHBUTTON|WS_CHILD,110,220,60,30,headrbox,NULL,maininst,NULL);
   cancelbuttn=CreateWindow("BUTTON","Cancel",BS_PUSHBUTTON|WS_CHILD,190,220,60,30,headrbox,NULL,maininst,NULL);
   edit1=CreateWindow("EDIT",NULL,WS_BORDER|WS_CHILD|WS_VISIBLE,5,10,200,20,headrbox,NULL,maininst,NULL);
   edit2=CreateWindow("EDIT",NULL,WS_BORDER|WS_CHILD|WS_VISIBLE,5,31,200,20,headrbox,NULL,maininst,NULL);
   edit3=CreateWindow("EDIT",NULL,WS_BORDER|WS_CHILD|WS_VISIBLE,5,52,200,20,headrbox,NULL,maininst,NULL);
   edit4=CreateWindow("EDIT",NULL,WS_BORDER|WS_CHILD|WS_VISIBLE,5,73,200,20,headrbox,NULL,maininst,NULL);
   edit5=CreateWindow("EDIT",NULL,WS_BORDER|WS_CHILD|WS_VISIBLE,5,94,200,20,headrbox,NULL,maininst,NULL);
   edit6=CreateWindow("EDIT",NULL,WS_BORDER|WS_CHILD|WS_VISIBLE,5,115,200,20,headrbox,NULL,maininst,NULL);
   edit7=CreateWindow("EDIT",NULL,WS_BORDER|WS_CHILD|WS_VISIBLE,5,136,200,20,headrbox,NULL,maininst,NULL);
   edit8=CreateWindow("EDIT",NULL,WS_BORDER|WS_CHILD|WS_VISIBLE,5,157,200,20,headrbox,NULL,maininst,NULL);
   edit9=CreateWindow("EDIT",NULL,WS_BORDER|WS_CHILD|WS_VISIBLE|ES_NUMBER,5,178,200,20,headrbox,NULL,maininst,NULL);
   text1=CreateWindow("STATIC","Level Subtitle (No spaces. Use underscore)",WS_CHILD|SS_SIMPLE|WS_VISIBLE,205,10,325,20,headrbox,NULL,maininst,NULL);
   text2=CreateWindow("STATIC","Level Title (No spaces. Use underscore)",WS_CHILD|SS_SIMPLE|WS_VISIBLE,205,31,325,20,headrbox,NULL,maininst,NULL);
   text3=CreateWindow("STATIC","Path to main .bmp file from dat file location",WS_CHILD|SS_SIMPLE|WS_VISIBLE,205,52,325,20,headrbox,NULL,maininst,NULL);
   text4=CreateWindow("STATIC","Background midi music file from dat file location",WS_CHILD|SS_SIMPLE|WS_VISIBLE,205,73,325,20,headrbox,NULL,maininst,NULL);
   text5=CreateWindow("STATIC","Level win .wav file from dat file location",WS_CHILD|SS_SIMPLE|WS_VISIBLE,205,94,325,20,headrbox,NULL,maininst,NULL);
   text6=CreateWindow("STATIC","Level oneup .wav file from dat file location",WS_CHILD|SS_SIMPLE|WS_VISIBLE,205,115,325,20,headrbox,NULL,maininst,NULL);
   text7=CreateWindow("STATIC","Level lose .wav file from dat file location",WS_CHILD|SS_SIMPLE|WS_VISIBLE,205,136,325,20,headrbox,NULL,maininst,NULL);
   text8=CreateWindow("STATIC","Level score count .wav file from dat file location",WS_CHILD|SS_SIMPLE|WS_VISIBLE,205,157,325,20,headrbox,NULL,maininst,NULL);
   text9=CreateWindow("STATIC","Time bonus for level",WS_CHILD|SS_SIMPLE|WS_VISIBLE,205,178,290,20,headrbox,NULL,maininst,NULL);

}

void CreateNewEnemBox(void)
{
   enemybox=CreateWindowEx(WS_EX_TOOLWINDOW|WS_EX_TOPMOST,
                          "New Enemy Box",
                          "Create New Enemy",
                          WS_OVERLAPPED|WS_SIZEBOX,
                         (workarea.right/2-225)+50,(workarea.bottom/2-150)+50,
                          450,300,
                          NULL,
                          NULL,
                          maininst,
                          NULL);

   okbutton=CreateWindow("BUTTON","OK",BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE,110,170,60,30,enemybox,NULL,maininst,NULL);
   cancelbutton=CreateWindow("BUTTON","Cancel",BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE,190,170,60,30,enemybox,NULL,maininst,NULL);
   imageid=CreateWindow("COMBOBOX",NULL,WS_VSCROLL|CBS_DROPDOWN|WS_BORDER|WS_CHILD|WS_VISIBLE,10,10,75,90,enemybox,NULL,maininst,NULL);
   progid=CreateWindow("COMBOBOX",NULL,WS_VSCROLL|CBS_DROPDOWN|WS_BORDER|WS_CHILD|WS_VISIBLE,10,40,75,90,enemybox,NULL,maininst,NULL);
   imgidtext=CreateWindow("STATIC","Image Set to use for enemy",WS_CHILD|SS_SIMPLE|WS_VISIBLE,100,10,250,20,enemybox,NULL,maininst,NULL);
   progidtext=CreateWindow("STATIC","Enemy Program to use for enemy",WS_CHILD|SS_SIMPLE|WS_VISIBLE,100,40,250,20,enemybox,NULL,maininst,NULL);
   hpedit=CreateWindow("EDIT","2",ES_NUMBER|WS_BORDER|WS_CHILD|WS_VISIBLE,10,70,75,20,enemybox,NULL,maininst,NULL);
   hpedittext=CreateWindow("STATIC","Enemy hitpoints",WS_CHILD|SS_SIMPLE|WS_VISIBLE,100,70,250,20,enemybox,NULL,maininst,NULL);
   speededit=CreateWindow("EDIT","3",ES_NUMBER|WS_BORDER|WS_CHILD|WS_VISIBLE,10,100,75,20,enemybox,NULL,maininst,NULL);
   speededittext=CreateWindow("STATIC","Enemy speed",WS_CHILD|SS_SIMPLE|WS_VISIBLE,100,100,250,20,enemybox,NULL,maininst,NULL);
   anirateedit=CreateWindow("EDIT","5",ES_NUMBER|WS_BORDER|WS_CHILD|WS_VISIBLE,10,130,75,20,enemybox,NULL,maininst,NULL);
   anirateedittext=CreateWindow("STATIC","Enemy animation rate (updated every _ frames)",WS_CHILD|SS_SIMPLE|WS_VISIBLE,100,130,350,20,enemybox,NULL,maininst,NULL);

}

LRESULT cneproc(HWND hwnd, UINT wMsg, WPARAM wParam, LPARAM lParam)  //New enemy box message loop
{
 switch(wMsg)
 {
  case WM_COMMAND:{
      char convert[15];
      SendMessage(imageid,CB_GETLBTEXT,SendMessage(imageid,CB_GETCURSEL,0,0),(LPARAM)&convert);
      int chacha=atoi(convert);
      HDC Hdc=GetDC(enemybox);
      HDC hdc=CreateCompatibleDC(Hdc);
      SelectObject(hdc,thepict);
      RECT rect=makrect(325,5,325+120,5+120);
      FillRect(Hdc,&rect,(HBRUSH)COLOR_WINDOW);
      BitBlt(Hdc,325,5,ImgSets[chacha].width+2,ImgSets[chacha].height+2,hdc,ImgSets[chacha].x,ImgSets[chacha].y,SRCCOPY);
      ReleaseDC(enemybox,Hdc);
      DeleteDC(hdc);
   if(lParam==(LPARAM)cancelbutton)ShowWindow(enemybox,SW_HIDE);  //if cancel pressed
   if(lParam==(LPARAM)okbutton)
    {
    //SendMessage(imageid,CB_GETCURSEL,0,0);
    unsigned int emptyenemy=-1;
    for(int n=0;n<15;n++)
    {
     if(!enemies[n].alive)
     {
     emptyenemy=n;
     break;
     }
    }
    if(emptyenemy==-1)
     {
     MessageBox(hWnd,"Cannot have more than 15 enemies.","Dat file Loading Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
     }
     else  //if an empty enemy slot is found
     {
      char convert[15];
      enemies[emptyenemy].alive=true;
      curenem++;
      SendMessage(imageid,CB_GETLBTEXT,SendMessage(imageid,CB_GETCURSEL,0,0),(LPARAM)&convert);
      enemies[emptyenemy].ImgID=atoi(convert);
      SendMessage(progid,CB_GETLBTEXT,SendMessage(progid,CB_GETCURSEL,0,0),(LPARAM)&convert);
      enemies[emptyenemy].programID=atoi(convert);
      GetWindowText(hpedit,(char*)&convert,15);
      enemies[emptyenemy].HP=atoi((char*)&convert);
      GetWindowText(speededit,(char*)&convert,15);
      enemies[emptyenemy].speed=atoi((char*)&convert);
      GetWindowText(anirateedit,(char*)&convert,15);
      enemies[emptyenemy].anirate=atoi((char*)&convert);
      enemies[emptyenemy].x=1;
      enemies[emptyenemy].y=1;
      RedrawTheThingy();

     }
    ShowWindow(enemybox,SW_HIDE);
    }
   break;
   }
  default:return DefWindowProc(hwnd, wMsg, wParam, lParam);
 }
}

void MakeEditProgBox(void)
{
  moveeditbox=CreateWindowEx(WS_EX_TOOLWINDOW|WS_EX_TOPMOST,"EnemProg Box","Edit Enemy Program",WS_OVERLAPPED|WS_SIZEBOX,(workarea.right/2-225)+50,(workarea.bottom/2-125)+50,450,250,NULL,NULL,maininst,NULL);
  IDtext=CreateWindow("STATIC","Program for editing",WS_CHILD|SS_SIMPLE|WS_VISIBLE,10,10,250,20,moveeditbox,NULL,maininst,NULL);
  donebuttn=CreateWindow("BUTTON","DONE",BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE,110,170,75,30,moveeditbox,NULL,maininst,NULL);
  delbuttn=CreateWindow("BUTTON","Delete Prog",BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE,190,170,90,30,moveeditbox,NULL,maininst,NULL);
  addmovbuttn=CreateWindow("BUTTON","Add",BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE,275,37,35,20,moveeditbox,NULL,maininst,NULL);
  addprogbuttn=CreateWindow("BUTTON","Add Prog",BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE,285,170,90,30,moveeditbox,NULL,maininst,NULL);  
  IDcombo=CreateWindow("COMBOBOX",NULL,WS_VSCROLL|CBS_DROPDOWNLIST|WS_BORDER|WS_CHILD|WS_VISIBLE,185,10,75,80,moveeditbox,NULL,maininst,NULL);
  curtext=CreateWindow("STATIC","Movement within program",WS_CHILD|SS_SIMPLE|WS_VISIBLE,20,35,250,20,moveeditbox,NULL,maininst,NULL);
  curcombo=CreateWindow("COMBOBOX",NULL,WS_VSCROLL|CBS_DROPDOWNLIST|WS_BORDER|WS_CHILD|WS_VISIBLE,195,35,75,80,moveeditbox,NULL,maininst,NULL);
  dirtext=CreateWindow("STATIC","Direction",WS_CHILD|SS_SIMPLE|WS_VISIBLE,30,60,250,20,moveeditbox,NULL,maininst,NULL);
  dircombo=CreateWindow("COMBOBOX",NULL,WS_VSCROLL|CBS_DROPDOWNLIST|WS_BORDER|WS_CHILD|WS_VISIBLE,215,60,105,80,moveeditbox,NULL,maininst,NULL);
  stepstext=CreateWindow("STATIC","Number of steps",WS_CHILD|SS_SIMPLE|WS_VISIBLE,30,85,250,20,moveeditbox,NULL,maininst,NULL);
  stepsedit=CreateWindow("EDIT","",ES_NUMBER|WS_BORDER|WS_CHILD|WS_VISIBLE,215,85,75,20,moveeditbox,NULL,maininst,NULL);
  framestext=CreateWindow("STATIC","Cycle between frames X and Y",WS_CHILD|SS_SIMPLE|WS_VISIBLE,30,110,250,20,moveeditbox,NULL,maininst,NULL);
  framestartcombo=CreateWindow("COMBOBOX",NULL,WS_VSCROLL|CBS_DROPDOWNLIST|WS_BORDER|WS_CHILD|WS_VISIBLE,30,130,75,80,moveeditbox,NULL,maininst,NULL);
  frameendcombo=CreateWindow("COMBOBOX",NULL,WS_VSCROLL|CBS_DROPDOWNLIST|WS_BORDER|WS_CHILD|WS_VISIBLE,215,130,75,80,moveeditbox,NULL,maininst,NULL);
  char convert[5];
  for(int n=0;n<8;n++){
  itoa(n,(char*)&convert,10);
  SendMessage(framestartcombo,CB_ADDSTRING,0,(LPARAM)&convert);
  SendMessage(frameendcombo,CB_ADDSTRING,0,(LPARAM)&convert);
  }
  SendMessage(dircombo,CB_ADDSTRING,0,(LPARAM)"DOWNLEFT");
  SendMessage(dircombo,CB_ADDSTRING,0,(LPARAM)"DOWN");
  SendMessage(dircombo,CB_ADDSTRING,0,(LPARAM)"DOWNRIGHT");
  SendMessage(dircombo,CB_ADDSTRING,0,(LPARAM)"LEFT");
  SendMessage(dircombo,CB_ADDSTRING,0,(LPARAM)"STOP");
  SendMessage(dircombo,CB_ADDSTRING,0,(LPARAM)"RIGHT");
  SendMessage(dircombo,CB_ADDSTRING,0,(LPARAM)"UPLEFT");
  SendMessage(dircombo,CB_ADDSTRING,0,(LPARAM)"UP");
  SendMessage(dircombo,CB_ADDSTRING,0,(LPARAM)"UPRIGHT");
}

LRESULT eepproc(HWND hwnd, UINT wMsg, WPARAM wParam, LPARAM lParam)  //New enemy box message loop
{
 switch(wMsg)
 {
  case CBN_SELCHANGE:
  case WM_COMMAND:
  {
   if(lParam==(LPARAM)addprogbuttn)
   {
    int yadda=-1;
    for(int n=0;n<15;n++)
    {
     if(!movprogs[n].alive){yadda=n;break;}
    }
    if(yadda!=-1)
    {
     movprogs[yadda].alive=true;
     selectprog=yadda;
     lParam=(LPARAM)addmovbuttn;
     char lalala[15];
     itoa(yadda,(char*)&lalala,10);
     SendMessage(IDcombo,CB_ADDSTRING,0,(LPARAM)&lalala);
    }
   }
   if((lParam==(LPARAM)addmovbuttn)&&(selectprog!=-1))
   {
    int numofmovs=movprogs[selectprog].numofmovs;
    movprogs[selectprog].movement[numofmovs]=DIR_STOP;
    movprogs[selectprog].steps[numofmovs]=10;
    movprogs[selectprog].framestart[numofmovs]=0;
    movprogs[selectprog].frameend[numofmovs]=0;
    movprogs[selectprog].numofmovs++;
    char lalala[15];
    itoa(numofmovs,(char*)&lalala,10);
    SendMessage(curcombo,CB_ADDSTRING,0,(LPARAM)&lalala);
   }
   if(lParam==(LPARAM)IDcombo)
   {
    SendMessage(curcombo,CB_RESETCONTENT,0,0);
    char number[5];
    SendMessage(IDcombo,CB_GETLBTEXT,SendMessage(IDcombo,CB_GETCURSEL,0,0),(LPARAM)&number);
    selectprog=atoi((char*)&number);
     char convert[5];
     for(int n=0;n<movprogs[selectprog].numofmovs;n++){
     itoa(n,(char*)&convert,10);
     SendMessage(curcombo,CB_ADDSTRING,0,(LPARAM)&convert);
     }
    SendMessage(curcombo,CB_SETCURSEL,0,0);
   }
   int num=SendMessage(curcombo,CB_GETCURSEL,0,0);
   if((lParam==(LPARAM)curcombo)||(lParam==(LPARAM)IDcombo))
   {
    SendMessage(framestartcombo,CB_SETCURSEL,(WPARAM)movprogs[selectprog].framestart[num],0);
    SendMessage(frameendcombo,CB_SETCURSEL,(WPARAM)movprogs[selectprog].frameend[num],0);
    SendMessage(dircombo,CB_SETCURSEL,(WPARAM)movprogs[selectprog].movement[num]-1,0);
    char ness[5];
    itoa(movprogs[selectprog].steps[num],(char*)&ness,10);
    SetWindowText(stepsedit,(char*)&ness);
   }
   if(lParam==(LPARAM)framestartcombo)movprogs[selectprog].framestart[num]=SendMessage(framestartcombo,CB_GETCURSEL,0,0);
   if(lParam==(LPARAM)frameendcombo)movprogs[selectprog].frameend[num]=SendMessage(frameendcombo,CB_GETCURSEL,0,0);
   if(lParam==(LPARAM)dircombo)movprogs[selectprog].movement[num]=SendMessage(dircombo,CB_GETCURSEL,0,0)+1;
   if(lParam==(LPARAM)donebuttn)ShowWindow(moveeditbox,SW_HIDE);
   if((lParam==(LPARAM)delbuttn)&&(selectprog!=-1))
   {
       bool dependants=false;
       for(int n=0;n<15;n++)
       {
        if((enemies[n].alive)&&(enemies[n].programID==selectprog))
        {
         dependants=true;
         break;
        }
       }
      if(dependants)MessageBox(hWnd,"Enemy program is in use by an enemy.  Could not delete.","Editing Action Error",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST);
      if(!dependants)
      {
       if(selectprog!=-1)movprogs[selectprog].alive=false;
       selectprog=-1;
       SendMessage(IDcombo,CB_RESETCONTENT,0,0);
       for(int n=0;n<15;n++)
       {
       char lalala[15];
       itoa(n,(char*)&lalala,10);
       if(movprogs[n].alive)SendMessage(IDcombo,CB_ADDSTRING,0,(LPARAM)&lalala);
       }
      }
   }
   if((stuffloaded)&&(HIWORD(wParam)==EN_KILLFOCUS))
   {
   int num=SendMessage(curcombo,CB_GETCURSEL,0,0);
   char paula[10];
   GetWindowText(stepsedit,(char*)&paula,10);
   if(selectprog!=-1)movprogs[selectprog].steps[num]=atoi((char*)&paula);
   }
  break;
  }
  case WM_RBUTTONDOWN:
  case WM_LBUTTONDOWN:
  {
  SetFocus(moveeditbox);
  break;
  }
  default:return DefWindowProc(hwnd, wMsg, wParam, lParam);
 }
}
